diff -ur slackware64-current.2/source/l/cryptopp/cryptopp.SlackBuild slackware64-current.3/source/l/cryptopp/cryptopp.SlackBuild
--- slackware64-current.2/source/l/cryptopp/cryptopp.SlackBuild	2021-02-13 06:31:56.635945370 +0100
+++ slackware64-current.3/source/l/cryptopp/cryptopp.SlackBuild	2021-09-18 13:42:54.396971838 +0200
@@ -95,6 +95,11 @@
 # Cater to 64-bit Slackware:
 sed -i -e "s,(PREFIX)/lib,(PREFIX)/lib${LIBDIRSUFFIX},g" GNUmakefile
 
+# Disable NEON on armv5:
+sed -i -e "s/if defined(__arm__) || defined(__ARM_NEON)/if defined(__ARM_NEON)/" config.h
+# Fix building for bigendian or1k
+sed -i -e "s/defined(__ARMEB__)/defined(__ARMEB__) || defined(__or1k__)/" config.h
+
 # Compile and install:
 make all dynamic libcryptopp.pc $NUMJOBS \
   CXXFLAGS="${SLKCFLAGS} -DNDEBUG" LDFLAGS="${LDFLAGS}"
diff -ur slackware64-current.2/source/l/elfutils/elfutils.SlackBuild slackware64-current.3/source/l/elfutils/elfutils.SlackBuild
--- slackware64-current.2/source/l/elfutils/elfutils.SlackBuild	2024-10-21 10:48:00.569056539 +0200
+++ slackware64-current.3/source/l/elfutils/elfutils.SlackBuild	2025-05-19 10:56:25.766713128 +0200
@@ -71,6 +71,10 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z* || exit 1
 cd $PKGNAM-$VERSION
 
+# asm/perf_regs.h is not present on all architectures, fix it:
+# (https://sourceware.org/bugzilla/show_bug.cgi?id=32930)
+zcat $CWD/perf_regs.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/ffmpeg/ffmpeg.SlackBuild slackware64-current.3/source/l/ffmpeg/ffmpeg.SlackBuild
--- slackware64-current.2/source/l/ffmpeg/ffmpeg.SlackBuild	2024-02-09 00:19:22.862311554 +0100
+++ slackware64-current.3/source/l/ffmpeg/ffmpeg.SlackBuild	2025-02-08 17:37:55.484965195 +0100
@@ -198,6 +198,9 @@
 tar xf $CWD/$PKGNAM-$VERSION.tar.xz || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix arm assembly not-decimal label[s] (no more accepted on binutils-2.43):
+#zcat $CWD/binutils243_arm.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find -L . \
  \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
@@ -213,6 +219,7 @@
 
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -234,6 +241,7 @@
   $fontconfig \
   $freetype \
   $fribidi \
+  $EXTRACONF \
   $gnutls \
   $ladspa \
   $libass \
diff -ur slackware64-current.2/source/l/fftw/fftw.SlackBuild slackware64-current.3/source/l/fftw/fftw.SlackBuild
--- slackware64-current.2/source/l/fftw/fftw.SlackBuild	2023-10-05 21:37:51.119130844 +0200
+++ slackware64-current.3/source/l/fftw/fftw.SlackBuild	2025-05-06 15:11:27.474912485 +0200
@@ -54,18 +54,42 @@
 PKG=$TMP/package-$PKGNAM-$VERSION
 OUTPUT=${OUTPUT:-$TMP}
 
+QUAD=""
+
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
   SIMD="--enable-sse2 --disable-avx"
+  SIMDF="$SIMD"
+  QUAD="yes"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
   LIBDIRSUFFIX="64"
   SIMD="--enable-sse2 --disable-avx"
-else
-  SLKCFLAGS="-O2"
+  SIMDF="$SIMD"
+  QUAD="yes"
+elif [ "$ARCH" = "i586" ]; then
+  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+  LIBDIRSUFFIX=""
+  SIMD="--disable-sse2 --disable-avx"
+  SIMDF="$SIMD"
+  QUAD="yes"
+elif [ "$ARCH" = "armv7hl" ]; then
+  SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX=""
   SIMD=""
+  SIMDF="--enable-neon"
+elif [ "$ARCH" = "aarch64" ]; then
+  SLKCFLAGS="-O2"
+  LIBDIRSUFFIX="64"
+  SIMD=""
+  SIMDF="$SIMD"
+else
+  SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+  SIMD=${SIMD:-""}
+  SIMDF=${SIMDF:-""}
+  QUAD=${QUAD:-""}
 fi
 
 rm -rf $PKG
@@ -114,7 +146,7 @@
     --enable-threads \
     --enable-openmp \
     --enable-float \
-    $SIMD \
+    $SIMDF \
     --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
@@ -141,6 +177,8 @@
 make install-strip DESTDIR=$PKG || exit 1
 make clean
 
+if [ "$QUAD" != "" ]
+then
 # compile libfftw3q
 ./configure \
     --prefix=/usr \
@@ -159,6 +201,7 @@
 
 make $NUMJOBS || make || exit 1
 make install-strip DESTDIR=$PKG || exit 1
+fi
 
 # Don't ship .la files:
 rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
diff -ur slackware64-current.2/source/l/fuse/fuse.SlackBuild slackware64-current.3/source/l/fuse/fuse.SlackBuild
--- slackware64-current.2/source/l/fuse/fuse.SlackBuild	2021-02-13 06:31:57.244945337 +0100
+++ slackware64-current.3/source/l/fuse/fuse.SlackBuild	2021-09-18 13:42:54.546979410 +0200
@@ -72,6 +72,10 @@
 rm -rf $PKGNAM-$VERSION
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z* || exit 1
 cd $PKGNAM-$VERSION || exit 1
+
+# Fix AArch64 already defined __u64/__s64/__u32/__s32/__u16:
+zcat $CWD/fuse_kernel-types.patch.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/gc/gc.SlackBuild slackware64-current.3/source/l/gc/gc.SlackBuild
--- slackware64-current.2/source/l/gc/gc.SlackBuild	2021-02-13 06:31:57.244945337 +0100
+++ slackware64-current.3/source/l/gc/gc.SlackBuild	2021-09-18 13:42:54.546979410 +0200
@@ -74,6 +74,11 @@
 tar xvf $CWD/libatomic_ops-$LAO_VERSION.tar.?z || exit 1
 mv libatomic_ops-$LAO_VERSION libatomic_ops
 
+if [ "$ARCH" = "sparc" ]; then
+  # Disable sparcv9 code:
+  zcat $CWD/atomic_ops_sparcv8.diff.gz | patch -p1 --verbose || exit 1
+fi
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/gjs/gjs.SlackBuild slackware64-current.3/source/l/gjs/gjs.SlackBuild
--- slackware64-current.2/source/l/gjs/gjs.SlackBuild	2024-09-17 19:19:45.747016995 +0200
+++ slackware64-current.3/source/l/gjs/gjs.SlackBuild	2025-01-07 13:31:25.242739701 +0100
@@ -78,6 +78,7 @@
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
+export LDFLAGS="$SLKLDFLAGS"
 mkdir meson-build
 cd meson-build
 # Use "unshare -n" to avoid downloading sysprof:
diff -ur slackware64-current.2/source/l/glibc/glibc.SlackBuild slackware64-current.3/source/l/glibc/glibc.SlackBuild
--- slackware64-current.2/source/l/glibc/glibc.SlackBuild	2024-08-29 20:40:27.213835099 +0200
+++ slackware64-current.3/source/l/glibc/glibc.SlackBuild	2025-02-18 15:19:50.847947065 +0100
@@ -96,29 +96,46 @@
 # -fno-tree-vectorize -fno-tree-loop-vectorize -fno-tree-slp-vectorize
 # But since we're already requiring at least a pentium4, I'm not sure
 # what the benefit would be, so we won't do this yet.
-X86FLAGS32="-O3 -march=pentium4 -mtune=generic -mstackrealign -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer"
+X86FLAGS32="-O3 -mstackrealign -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer"
 X86FLAGS64="-O3 -march=x86-64 -mtune=generic -fPIC"
+i686ARCH="-march=pentium4 -mtune=generic"
 
 # I'll break this out as an option for fun  :-)
 case $ARCH  in
   i686)
-    OPTIMIZ="${X86FLAGS32}"
+    OPTIMIZ="${i686ARCH} ${X86FLAGS32}"
     LIBDIRSUFFIX=""
-    TARGET=${TARGET:-i686}
+    LIBDIRSUFFIXROOT="$LIBDIRSUFFIX"
+    ;;
+  i586)
+    OPTIMIZ="-O3 -march=i586 -mtune=i686 ${X86FLAGS32}"
+    LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT="$LIBDIRSUFFIX"
     ;;
   x86_64)
     OPTIMIZ="${X86FLAGS64}"
+    X86FLAGS32="${i686ARCH} ${X86FLAGS32}"
     LIBDIRSUFFIX="64"
-    TARGET=${TARGET:-x86_64}
+    LIBDIRSUFFIXROOT="$LIBDIRSUFFIX"
     TARGET32=${TARGET32:-i686}
     ;;
   *)
     OPTIMIZ="-O3"
     LIBDIRSUFFIX=""
-    TARGET=${TARGET:-"$ARCH"}
     ;;
 esac
 
+case $ARCH in
+    arm*) TARGET=${TARGET:-$ARCH-slackware-linux-gnueabi} ;;
+    *)    TARGET=${TARGET:-$ARCH-slackware-linux} ;;
+esac
+ 
+# Enable multi-arch only on specific platforms
+case $ARCH in
+  i?86|x86_64|arm*|aarch*|ppc*|riscv*|s390*) EXTRACONF="--enable-multi-arch";;
+esac
+
+
 # Hand off the $ARCH variable to $SLACKWARE_ARCH to avoid confusing glibc:
 SLACKWARE_ARCH=$ARCH
 unset ARCH
@@ -136,21 +153,75 @@
 # This function fixes a doinst.sh file for x86_64.
 # With thanks to Fred Emmott.
 fix_doinst() {
-  if [ "$LIBDIRSUFFIX" = "" ]; then
-    return;
-  fi;
   if [ "$MULTILIB" = "--enable-multilib" ]; then
     # Save a copy of this to append the 32-bit links later.
     cp -a install/doinst.sh install/doinst32.sh
   fi
-  # Fix "( cd usr/lib ;" occurrences
-  sed -i "s#lib ;#lib${LIBDIRSUFFIX} ;#" install/doinst.sh
+  if [ "x$LIBDIRSUFFIXROOT" != "x" ]; then
+  # Fix "( cd usr/lib ;" occurrences (should fix nothing)
+  sed -i "s#usr/lib ;#usr/lib${LIBDIRSUFFIX} ;#" install/doinst.sh
+  # Fix "( cd lib ;" occurrences
+  sed -i "s# lib ;# lib${LIBDIRSUFFIXROOT} ;#" install/doinst.sh
   # Fix "lib/" occurrences
-  sed -i "s#lib/#lib${LIBDIRSUFFIX}/#g" install/doinst.sh
+  sed -i "s#lib/#lib${LIBDIRSUFFIXROOT}/#g" install/doinst.sh
   # Fix "( cd lib" occurrences
-  sed -i "s#( cd lib\$#( cd lib${LIBDIRSUFFIX}#" install/doinst.sh
+  sed -i "s#( cd lib\$#( cd lib${LIBDIRSUFFIXROOT}#" install/doinst.sh
+  fi
   if [ "$SLACKWARE_ARCH" = "x86_64" ]; then
     sed -i 's#ld-linux#ld-linux-x86-64#g' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "arm" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.3#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "armv7hl" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.3#' install/doinst.sh
+    sed -i 's#ld-linux#ld-linux-armhf#g' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "aarch64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld-linux-aarch64#g' install/doinst.sh
+    if [[ "x$LIBDIRSUFFIX" != "x" ]]
+    then
+      # All binaries are linked by default to /lib/ld-linux-aarch64.so.1, so make sure
+      # the file/link exists
+      echo -e "\n# Make sure /lib/ld-linux-aarch64.so.1 links to the correct file\n\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld-linux-aarch64.so.1 . )\n" >> install/doinst.sh
+    fi
+  elif [ "${SLACKWARE_ARCH}" = "ppc64le" ]; then
+    sed -i 's#ld-linux#ld64#g' install/doinst.sh
+    # Fix missing old ld-x.xx.so.2 removal, since from 2.41 the ld64-x.xx.so.2 was not renamed:
+    sed -i 's|\(incoming/\*-\*\)|\1 ld-|' install/doinst.sh
+  elif [ "${SLACKWARE_ARCH}" = "ppc64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld64#g' install/doinst.sh
+    # Fix missing old ld-x.xx.so.1 removal, since from 2.41 the ld64-x.xx.so.1 was not renamed:
+    sed -i 's|\(incoming/\*-\*\)|\1 ld-|' install/doinst.sh
+  elif [ "${SLACKWARE_ARCH}" = "ppc" -o "${SLACKWARE_ARCH::4}" = "mips" -o "${SLACKWARE_ARCH}" = "hppa" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld#g' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "riscv64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld-linux-riscv64-lp64d#g' install/doinst.sh
+    # All binaries are linked by default to /lib/ld-linux-riscv64-lp64d.so.1, so make sure
+    # the file/link exists
+    echo -e "\n# Make sure /lib/ld-linux-riscv64-lp64d.so.1 links to the correct file\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld-linux-riscv64-lp64d.so.1 . )\n(cd lib64; ln -sf lp64d/ld-linux-riscv64-lp64d.so.1 . )\n" >> install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "s390x" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld64#g' install/doinst.sh
+    # Fix missing old ld-x.xx.so.1 removal, since from 2.41 the ld64-x.xx.so.1 was not renamed:
+    sed -i 's|\(incoming/\*-\*\)|\1 ld-|' install/doinst.sh
+    # All binaries are linked by default to /lib/ld64.so.1, so make sure
+    # the file/link exists
+    echo -e "\n# Make sure /lib/ld64.so.1 links to the correct file\n\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld64.so.1 . )\n" >> install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "or1k" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld-linux-or1k#g' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "alpha" ]; then
+    # Alpha adds .1 on some libraries, change it and make additional link
+    for lib in libresolv.so.2 libnsl.so.1 libm.so.6 libutil.so.1 libcrypt.so.1 libBrokenLocale.so.1 libdl.so.2
+    do
+      sed -i "s#$lib #$lib.1 #" install/doinst.sh
+      echo -e "(cd lib$LIBDIRSUFFIX; ln -s $lib.1 $lib 2>/dev/null)\n" >> install/doinst.sh
+    done
+  elif [ "$SLACKWARE_ARCH" = "loongarch64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.1#' install/doinst.sh
+    sed -i 's#ld-linux#ld-linux-loongarch-lp64d#g' install/doinst.sh
   fi
   if [ "$MULTILIB" = "--enable-multilib" ]; then
     echo "# Add 32-bit library links for multilib:"  >> install/doinst.sh
@@ -170,6 +240,10 @@
   zcat $CWD/glibc.ru_RU.CP1251.diff.gz | patch -p1 --verbose || exit 1
   # Don't use AM/PM format for date(1). That's just plain crazy.
   zcat $CWD/glibc-2.32.en_US.no.am.pm.date.format.diff.gz | patch -p1 --verbose || exit 1
+  # For some architectures, revert checking executable stack:
+  if [ "$SLACKWARE_ARCH" = "ppc" -o "$SLACKWARE_ARCH" = "hppa" -o "$SLACKWARE_ARCH" = "or1k" ]; then
+    zcat $CWD/reenable_execstack.diff.gz | patch -p1 --verbose || exit 1
+  fi
   # Other regression fixes from git:
   for git_patch in $CWD/patches/*.patch.gz ; do
     zcat $git_patch | patch -p1 --verbose || exit 1
@@ -195,7 +266,7 @@
 fi
 
 # Create an incoming directory structure for glibc to be built into:
-mkdir -p $PKG/lib${LIBDIRSUFFIX}
+mkdir -p $PKG/lib${LIBDIRSUFFIXROOT}
 mkdir -p $PKG/sbin
 mkdir -p $PKG/usr/bin
 mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}
@@ -246,7 +317,7 @@
     --enable-kernel=4.4 \
     --with-headers=/usr/include \
     --enable-add-ons \
-    --enable-multi-arch \
+    $EXTRACONF \
     --enable-profile \
     $DISABLE_NSCD \
     $WERROR \
@@ -255,7 +326,7 @@
     --with-tls \
     --with-__thread \
     --without-cvs \
-    $TARGET-slackware-linux || exit 1
+    $TARGET || exit 1
   make $NUMJOBS || exit 1
   make $NUMJOBS install install_root=$PKG || exit 1
   # Don't use this, as it makes the i18n package WAY bigger:
@@ -301,6 +372,14 @@
 ARCH=$SLACKWARE_ARCH LIBDIRSUFFIX=$LIBDIRSUFFIX SLKCFLAGS=$OPTIMIZ ./libxcrypt.build || exit 1
 popd
 
+# Set time64 as default on 32-bit architectures (only exception is or1k which 
+# has __TIMESIZE == 64 (/usr/include/bits/timesize.h).
+case $SLACKWARE_ARCH in
+  arm|armv7hl|hppa|mips|mipsel|ppc|sh4|i?86)
+    (cd $PKG/usr;zcat $CWD/time64default.diff.gz | patch -p1 --no-backup-if-mismatch --verbose) || exit 1
+  ;;
+esac
+
 # We've always had an sln symlink in /bin, so let's make sure it
 # remains there so as not to break any scripts that might need it:
 mkdir -p $PKG/bin
@@ -310,7 +389,7 @@
 # /usr/lib/debug/ and stripping the debugging symbols from all the other
 # libraries.
 mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}/debug
-cp -a $PKG/lib${LIBDIRSUFFIX}/l*.so* $PKG/usr/lib${LIBDIRSUFFIX}/debug
+cp -a $PKG/lib${LIBDIRSUFFIXROOT}/l*.so* $PKG/usr/lib${LIBDIRSUFFIX}/debug
 cp -a $PKG/usr/lib${LIBDIRSUFFIX}/*.a $PKG/usr/lib${LIBDIRSUFFIX}/debug
 # Don't need debug+profile:
 ( cd $PKG/usr/lib${LIBDIRSUFFIX}/debug ; rm -f *_p.* )
@@ -328,6 +407,30 @@
 #mv $PKG/usr/lib${LIBDIRSUFFIX}/debug/*_p.a $PKG/usr/lib${LIBDIRSUFFIX}
 # It might be best to put the unstripped and profiling libraries in glibc-debug and glibc-profile.
 
+if [ "$SLACKWARE_ARCH" = "aarch64" -a "$LIBDIRSUFFIX" = "64" ]
+then
+  # On aarch64 the default linker is on /lib/ld-linux-aarch64.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64 so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld-linux-aarch64.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
+if [ "$SLACKWARE_ARCH" = "riscv64" ]
+then
+  # On riscv64 the default linker is on /lib/ld-linux-riscv64-lp64d.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64/lp64d so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld-linux-riscv64-lp64d.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
+if [ "$SLACKWARE_ARCH" = "s390x" ]
+then
+  # On s390x the default linker is on /lib/ld64.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64 so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld64.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
 # I don't think "strip -g" causes the pthread problems.  It's --strip-unneeded that does.
 strip -g $PKG/usr/lib${LIBDIRSUFFIX}/lib*.a
 if [ "$MULTILIB" = "--enable-multilib" ]; then
@@ -457,7 +560,7 @@
 chmod 755 etc/profile.d/*
 mkdir -p lib${LIBDIRSUFFIX}
 cp -a $PKG/lib${LIBDIRSUFFIX}/* lib${LIBDIRSUFFIX}
-( cd lib${LIBDIRSUFFIX}
+( cd lib${LIBDIRSUFFIXROOT}
   mkdir incoming
   mv *so* incoming
   mv incoming/libmemusage.so .
@@ -553,7 +656,7 @@
 sed -i "s/@@VERSION@@/$VERSION/g" install/doinst.sh
 # Call the function to fix doinst.sh where $LIBDIRSUFFIX is needed:
 fix_doinst
-( cd lib${LIBDIRSUFFIX}
+( cd lib${LIBDIRSUFFIXROOT}
   mkdir incoming
   mv *so* incoming
   mv incoming/libmemusage.so .
diff -ur slackware64-current.2/source/l/gnu-efi/gnu-efi.SlackBuild slackware64-current.3/source/l/gnu-efi/gnu-efi.SlackBuild
--- slackware64-current.2/source/l/gnu-efi/gnu-efi.SlackBuild	2021-08-17 21:01:07.631022697 +0200
+++ slackware64-current.3/source/l/gnu-efi/gnu-efi.SlackBuild	2021-09-18 13:42:54.606982438 +0200
@@ -71,6 +71,10 @@
 chown -R root:root .
 chmod -R u+w,go+r-w,a-s .
 
+# gnu-efi search "initplat.c" in lib/$ARCH, but ARCH is wrongly set
+SLACKWARE_ARCH=$ARCH
+unset ARCH
+
 sed -i "s,/usr/local,/usr,g" Make.defaults
 
 make CPPFLAGS="$SLKCFLAGS" || exit 1
@@ -89,6 +93,9 @@
 )
 strip -g $PKG/usr/lib${LIBDIRSUFFIX}/libefi.a
 
+# Restore ARCH after library build
+ARCH=$SLACKWARE_ARCH
+
 mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
 cp -a ChangeLog README* \
  $PKG/usr/doc/$PKGNAM-$VERSION
diff -ur slackware64-current.2/source/l/gobject-introspection/gobject-introspection.SlackBuild slackware64-current.3/source/l/gobject-introspection/gobject-introspection.SlackBuild
--- slackware64-current.2/source/l/gobject-introspection/gobject-introspection.SlackBuild	2024-11-21 22:52:42.469051225 +0100
+++ slackware64-current.3/source/l/gobject-introspection/gobject-introspection.SlackBuild	2025-01-07 13:31:25.552756283 +0100
@@ -93,7 +93,7 @@
   --buildtype=release \
   -Dgtk_doc=false \
   .. || exit 1
-  "${NINJA:=ninja}" $NUMJOBS || exit 1
+  "${NINJA:=ninja}" $NUMJOBS || $NINJA || exit 1
   DESTDIR=$PKG $NINJA install || exit 1
 cd ..
 
diff -ur slackware64-current.2/source/l/gstreamer/gstreamer.SlackBuild slackware64-current.3/source/l/gstreamer/gstreamer.SlackBuild
--- slackware64-current.2/source/l/gstreamer/gstreamer.SlackBuild	2024-08-22 12:33:30.539047264 -0000
+++ slackware64-current.3/source/l/gstreamer/gstreamer.SlackBuild	2025-04-02 14:13:23.952112650 -0000
@@ -82,6 +82,9 @@
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
+if [ "$SLKLDFLAGS" != "" ]; then
+  export LDFLAGS="$SLKLDFLAGS"
+fi
 mkdir meson-build
 cd meson-build
 meson setup \
diff -ur slackware64-current.2/source/l/gst-plugins-bad-free/gst-plugins-bad-free.SlackBuild slackware64-current.3/source/l/gst-plugins-bad-free/gst-plugins-bad-free.SlackBuild
--- slackware64-current.2/source/l/gst-plugins-bad-free/gst-plugins-bad-free.SlackBuild	2024-04-12 10:23:40.017081528 +0200
+++ slackware64-current.3/source/l/gst-plugins-bad-free/gst-plugins-bad-free.SlackBuild	2025-04-04 13:16:37.646889761 +0200
@@ -81,6 +81,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION
 
+# Fix missing packing sizes for 32bit platforms:
+zcat $CWD/mfx_packing_32bit.diff.gz | patch --verbose -p1 || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -91,6 +91,9 @@
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
+if [ "$SLKLDFLAGS" != "" ]; then
+  export LDFLAGS="$SLKLDFLAGS"
+fi
 mkdir meson-build
 cd meson-build
 meson setup \
diff -ur slackware64-current.2/source/l/gst-plugins-base/gst-plugins-base.SlackBuild slackware64-current.3/source/l/gst-plugins-base/gst-plugins-base.SlackBuild
--- slackware64-current.2/source/l/gst-plugins-base/gst-plugins-base.SlackBuild	2025-03-20 10:20:38.799632796 -0000
+++ slackware64-current.3/source/l/gst-plugins-base/gst-plugins-base.SlackBuild	2025-04-02 16:33:59.838607153 -0000
@@ -87,6 +87,9 @@
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
+if [ "$SLKLDFLAGS" != "" ]; then
+  export LDFLAGS="$SLKLDFLAGS"
+fi
 mkdir meson-build
 cd meson-build
 meson setup \
diff -ur slackware64-current.2/source/l/gtk+2/gtk+2.SlackBuild slackware64-current.3/source/l/gtk+2/gtk+2.SlackBuild
--- slackware64-current.2/source/l/gtk+2/gtk+2.SlackBuild	2024-05-11 00:39:54.902290650 +0200
+++ slackware64-current.3/source/l/gtk+2/gtk+2.SlackBuild	2025-01-07 13:31:25.782768586 +0100
@@ -122,9 +122,9 @@
 # Check the host value that is passed to the compile to the one in this script:
 host="$ARCH-slackware-linux-gnu"
 compile_host=$(grep 'host_triplet =' gtk/Makefile | sed -e "s/.* = //")
-if [ "x$compile_host" != "x$host" ]; then
-  echo "Host mismatch: compile='$compile_host', SlackBuild='$host'" && exit 1
-fi
+#if [ "x$compile_host" != "x$host" ]; then
+#  echo "Host mismatch: compile='$compile_host', SlackBuild='$host'" && exit 1
+#fi
 
 make install \
   RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false \
@@ -147,7 +147,7 @@
 # for places where we have two copies of the GTK+ package installed.
 # (we might have x86_64 and i486 packages on the same system, for example.)
 case "$host" in
-  s390x*|x86_64*)
+  s390x*|*64*)
    mv $PKG/usr/bin/gtk-query-immodules-2.0{,-64}
    ( cd $PKG/usr/bin
      ln -sf gtk-query-immodules-2.0-64 gtk-query-immodules-2.0
diff -ur slackware64-current.2/source/l/gtk4/gtk4.SlackBuild slackware64-current.3/source/l/gtk4/gtk4.SlackBuild
--- slackware64-current.2/source/l/gtk4/gtk4.SlackBuild	2024-08-23 00:31:48.133391789 +0200
+++ slackware64-current.3/source/l/gtk4/gtk4.SlackBuild	2024-11-29 02:18:12.853762964 +0100
@@ -71,6 +71,10 @@
 tar xf $CWD/gtk-$VERSION.tar.?z || exit 1
 cd gtk-$VERSION || exit 1
 
+# Fix missing FE_UPWARD (or1k-soft, sh4), FE_DOWNWARD (or1k-soft, sh4)
+# and FE_TOWARDZERO (or1k-soft):
+zcat $CWD/fe_rounding.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/jemalloc/jemalloc.SlackBuild slackware64-current.3/source/l/jemalloc/jemalloc.SlackBuild
--- slackware64-current.2/source/l/jemalloc/jemalloc.SlackBuild	2021-02-13 06:31:58.489945268 +0100
+++ slackware64-current.3/source/l/jemalloc/jemalloc.SlackBuild	2023-06-17 17:07:39.954674081 +0200
@@ -71,6 +74,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing alignment for SPARC 32 bit:
+zcat $CWD/lg_quantum_sparc.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find -L . \
  \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
diff -ur slackware64-current.2/source/l/lensfun/lensfun.SlackBuild slackware64-current.3/source/l/lensfun/lensfun.SlackBuild
--- slackware64-current.2/source/l/lensfun/lensfun.SlackBuild	2024-11-22 00:49:17.107207695 +0100
+++ slackware64-current.3/source/l/lensfun/lensfun.SlackBuild	2024-12-07 12:42:05.144963299 +0100
@@ -53,6 +53,7 @@
   LIBDIRSUFFIX=""
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC"
+  CMAKE_EXTRA="-DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON"
   LIBDIRSUFFIX="64"
 else
   SLKCFLAGS="-O2"
@@ -89,8 +90,7 @@
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
     -DBUILD_LENSTOOL=ON \
-    -DBUILD_FOR_SSE=ON \
-    -DBUILD_FOR_SSE2=ON \
+    $CMAKE_EXTRA \
     -DBUILD_TESTS=OFF \
     -DINSTALL_HELPER_SCRIPTS=ON \
     .. || exit 1
diff -ur slackware64-current/source/l/libcap/libcap.SlackBuild slackware64-current.2/source/l/libcap/libcap.SlackBuild
--- slackware64-current/source/l/libcap/libcap.SlackBuild	2021-03-14 18:51:45.109039507 +0100
+++ slackware64-current.2/source/l/libcap/libcap.SlackBuild	2025-04-02 20:20:58.917813553 +0200
@@ -86,6 +86,9 @@
 # Put the pkgconfig files in the proper location:
 zcat $CWD/libcap.pkgconfig.path.diff.gz | patch -p1 --verbose || exit 1
 
+# Add architectures not supported (alpha, ork1, sh4, hppa):
+zcat $CWD/add_architectures.diff.gz | patch -p1 --verbose || exit 1
+
 # Set the CFLAGS
 sed -i "s/^\(DEBUG =\).*/\1$SLKCFLAGS/" Make.Rules
 
@@ -96,7 +96,7 @@
 sed -i 's@^BUILD_GPERF@#\0@' Make.Rules
 
 make DYNAMIC=yes GOLANG=$GOSUPPORT || exit 1
-make install RAISE_SETFCAP=no GOLANG=$GOSUPPORT DESTDIR=$PKG man_prefix=/usr || exit 1
+make install RAISE_SETFCAP=no GOLANG=$GOSUPPORT DESTDIR=$PKG man_prefix=/usr lib=lib${LIBDIRSUFFIX} || exit 1
 chmod 755 $PKG/lib${LIBDIRSUFFIX}/libcap.so*
 
 # Don't ship the static libcap.a. Leave libpsx.a alone, though - there's no
diff -ur slackware64-current/source/l/libcdio/libcdio.SlackBuild slackware64-current.2/source/l/libcdio/libcdio.SlackBuild
--- slackware64-current/source/l/libcdio/libcdio.SlackBuild	2024-05-10 13:29:43.634117601 +0200
+++ slackware64-current.2/source/l/libcdio/libcdio.SlackBuild	2024-12-01 21:39:23.980292172 +0100
@@ -68,6 +68,10 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.?z || exit 1
 cd ${PKGNAM}-$VERSION
 
+# On 32 bit platform, since the introduction of time64 by default,
+# need to define _LARGEFILE64_SOURCE:
+zcat $CWD/largefile64_source.diff.gz | patch -p1 --verbose || exit 1
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current/source/l/libffi/libffi.SlackBuild slackware64-current.2/source/l/libffi/libffi.SlackBuild
--- slackware64-current/source/l/libffi/libffi.SlackBuild	2022-10-29 12:56:09.465547088 +0200
+++ slackware64-current.2/source/l/libffi/libffi.SlackBuild	2024-02-26 13:20:38.145654765 +0100
@@ -104,6 +104,11 @@
   --disable-exec-static-tramp \
   --build=$ARCH-slackware-linux || exit 1
 
+# On Alpha and MIPS64 LONG_DOUBLE is not correctly detectd, force it:
+if [ "$ARCH" = "alpha" -o "$ARCH" = "mips64el" ]; then
+  sed -i -e 's|/. #undef HAVE_LONG_DOUBLE ./|#define HAVE_LONG_DOUBLE 1|' ${ARCH}-*/fficonfig.h
+fi
+
 make || exit 1
 make install DESTDIR=$PKG || exit 1
 
diff -ur slackware64-current.2/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild slackware64-current.3/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild
--- slackware64-current.2/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild	2021-04-24 05:12:21.810644855 +0200
+++ slackware64-current.3/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild	2021-09-18 13:42:54.916998086 +0200
@@ -102,6 +104,7 @@
     -DCMAKE_INSTALL_DOCDIR=/usr/doc/libjpeg-turbo-${VERSION} \
     -DCMAKE_INSTALL_MANDIR=/usr/man \
     -DENABLE_STATIC=OFF \
+    $WITH_SIMD \
     .. || exit 1
   make $NUMJOBS || make || exit 1
   make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/libkarma/libkarma.SlackBuild slackware64-current.3/source/l/libkarma/libkarma.SlackBuild
--- slackware64-current.2/source/l/libkarma/libkarma.SlackBuild	2021-02-13 06:31:59.754945198 +0100
+++ slackware64-current.3/source/l/libkarma/libkarma.SlackBuild	2021-09-18 13:42:54.916998086 +0200
@@ -79,7 +79,7 @@
 make $NUMJOBS PREFIX=/usr || make PREFIX=/usr || exit 1
 make install PREFIX=$PKG/usr || exit 1
 
-if [ "$ARCH" = "x86_64" ]; then
+if [ "$LIBDIRSUFFIX" != "" ]; then
   mv $PKG/usr/lib $PKG/usr/lib${LIBDIRSUFFIX}
 fi
 rm $PKG/usr/lib${LIBDIRSUFFIX}/*.a
diff -ur slackware64-current.2/source/l/libmad/libmad.SlackBuild slackware64-current.3/source/l/libmad/libmad.SlackBuild
--- slackware64-current.2/source/l/libmad/libmad.SlackBuild	2021-02-13 06:31:59.776945197 +0100
+++ slackware64-current.3/source/l/libmad/libmad.SlackBuild	2021-09-18 13:42:54.957000105 +0200
@@ -81,6 +81,11 @@
 # Remove obsolete --force-mem optimization:
 sed -i "s/-fforce-mem//g" configure
 
+# On MIPS platform, from gcc 4.4, =h constraint (save HI register) was removed 
+# to avoid unpredictable code sequences, but the compiler will generate the
+# best optimized code with at least -O2 and generic 64-bit C code.
+sed -i 's/(FPM_64BIT/(FPM_64BIT) || defined(FPM_MIPS/' fixed.h
+
 # Configure:
 CFLAGS="$SLKCFLAGS" \
 ./configure \
diff -ur slackware64-current.2/source/l/librsvg/librsvg.SlackBuild slackware64-current.3/source/l/librsvg/librsvg.SlackBuild
--- slackware64-current.2/source/l/librsvg/librsvg.SlackBuild	2024-08-17 19:39:39.878387407 +0200
+++ slackware64-current.3/source/l/librsvg/librsvg.SlackBuild	2025-02-12 12:50:32.320534174 +0100
@@ -101,6 +101,12 @@
 EOF
 fi
 
+# On 32 mips, the error "Undefined temporary symbol $BB14_1" will raise by newer rust. 
+# Adding "-C opt-level=1" is a workaround
+if [ "$SLKRUSTFLAGS" != "" ]; then
+  export RUSTFLAGS="$SLKRUSTFLAGS"
+fi
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
diff -ur slackware64-current.2/source/l/libsigsegv/libsigsegv.SlackBuild slackware64-current.3/source/l/libsigsegv/libsigsegv.SlackBuild
--- slackware64-current.2/source/l/libsigsegv/libsigsegv.SlackBuild	2022-01-09 03:34:13.178952636 +0100
+++ slackware64-current.3/source/l/libsigsegv/libsigsegv.SlackBuild	2025-01-07 13:31:27.162842401 +0100
@@ -70,6 +70,9 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.?z || exit 1
 cd ${PKGNAM}-$VERSION || exit 1
 
+# Fix incorrect NetBSD detection on alpha platform:
+zcat $CWD/alpha_linux.diff.gz | patch -p1 --verbose || exit 1
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/l/libtheora/libtheora.SlackBuild slackware64-current.3/source/l/libtheora/libtheora.SlackBuild
--- slackware64-current.2/source/l/libtheora/libtheora.SlackBuild	2021-09-18 13:40:06.318488999 +0200
+++ slackware64-current.3/source/l/libtheora/libtheora.SlackBuild	2025-05-22 10:43:25.662870324 -0000
@@ -88,10 +88,12 @@
 
 # Configure:
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="-lm" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
   --disable-static \
+  $EXTRACONF \
   --build=$ARCH-slackware-linux || exit 1
 
 # Build and install:
diff -ur slackware64-current.2/source/l/libtraceevent/libtraceevent.SlackBuild slackware64-current.3/source/l/libtraceevent/libtraceevent.SlackBuild
--- slackware64-current.2/source/l/libtraceevent/libtraceevent.SlackBuild	2024-12-24 16:02:08.645821434 +0100
+++ slackware64-current.3/source/l/libtraceevent/libtraceevent.SlackBuild	2025-06-13 11:34:19.934997162 +0200
@@ -72,6 +72,12 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix alpha libdir (not lib64)
+if [ "$ARCH" = "alpha" ]
+then
+  sed -i 's/= lib64/= lib/' Makefile
+fi
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/libtracefs/libtracefs.SlackBuild slackware64-current.3/source/l/libtracefs/libtracefs.SlackBuild
--- slackware64-current.2/source/l/libtracefs/libtracefs.SlackBuild	2025-05-06 12:42:25.557788741 +0200
+++ slackware64-current.3/source/l/libtracefs/libtracefs.SlackBuild	2025-06-13 14:31:35.224105676 +0200
@@ -72,6 +72,12 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix alpha libdir (not lib64)
+if [ "$ARCH" = "alpha" ]
+then
+  sed -i 's/= lib64/= lib/' Makefile
+fi
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
